// D-type Flip Flop Implementation for Linear Feedback Shift Register Layer
module dff_ar (
  input d,reset,clock,enable,
  output reg q
  );
  
  always @(posedge clock, negedge reset) begin
    if (!reset)
      q <=1'b1; //sets the content of the 16-bit register to 1's
    else
      if (enable) //the Idle State Detector authorizes data shifting
        q <=d;
      end
endmodule
    
