// D-type Flip Flop Implementation for Reconfigurable Multiple Input Signature Register Layer
module dff_ar_rec (
  input d,reset,clock,enable,
  output reg q
  );
  
  always @(posedge clock, negedge reset) begin
    if (!reset)
      q <=1'b0; //sets the content of the 16-bit register to 0's
    else
      if (enable) //the Idle State Detector authorizes data shifting
        q <=d;
      end
endmodule
