// Linear Feedback Shift Register Layer Implementation of a Given XOR Configuration
module lfsr_16bit(
  input enable,reset,clock,
  output [15:0]q
  );
  
  dff_ar DFF0 ( .d(q[15]),
                .reset(reset),
                .clock(clock),
                .enable(enable),
                .q(q[0])
               );
                
  dff_ar DFF1 ( .d(q[15]^q[0]),
                .reset(reset),
                .clock(clock),
                .enable(enable),
                .q(q[1])
               ); 
                
  dff_ar DFF2 ( .d(q[1]),
                .reset(reset),
                .clock(clock),
                .enable(enable),
                .q(q[2])
               ); 
                 
  dff_ar DFF3 ( .d(q[15]^q[2]),
                .reset(reset),
                .clock(clock),
                .enable(enable),
                .q(q[3])
               ); 
                
  dff_ar DFF4 ( .d(q[3]),
                .reset(reset),
                .clock(clock),
                .enable(enable),
                .q(q[4])
               ); 
          
  dff_ar DFF5 ( .d(q[4]),
                .reset(reset),
                .clock(clock),
                .enable(enable),
                .q(q[5])
                );  
                
  dff_ar DFF6 ( .d(q[5]),
                .reset(reset),
                .clock(clock),
                .enable(enable),
                .q(q[6])
               );   
                
  dff_ar DFF7 ( .d(q[6]),
                .reset(reset),
                .clock(clock),
                .enable(enable),
                .q(q[7])
               );  
                
  dff_ar DFF8 ( .d(q[7]),
                .reset(reset),
                .clock(clock),
                .enable(enable),
                .q(q[8])
                );  
                
  dff_ar DFF9 ( .d(q[8]),
                .reset(reset),
                .clock(clock),
                .enable(enable),
                .q(q[9])
               );               
                         
  dff_ar DFF10 ( .d(q[9]),
                 .reset(reset),
                 .clock(clock),
                 .enable(enable),
                 .q(q[10])
                );                    

  dff_ar DFF11 ( .d(q[10]),
                 .reset(reset),
                 .clock(clock),
                 .enable(enable),
                 .q(q[11])
                );  
  
  dff_ar DFF12 ( .d(q[15]^q[11]),
                 .reset(reset),
                 .clock(clock),
                 .enable(enable),
                 .q(q[12])
                );  
                
  dff_ar DFF13 ( .d(q[12]),
                 .reset(reset),
                 .clock(clock),
                 .enable(enable),
                 .q(q[13])
                );  
                
  dff_ar DFF14 ( .d(q[13]),
                 .reset(reset),
                 .clock(clock),
                 .enable(enable),
                 .q(q[14])
                ); 
                
  dff_ar DFF15 ( .d(q[14]),
                 .reset(reset),
                 .clock(clock),
                 .enable(enable),
                 .q(q[15])
                ); 
endmodule
                